export type Constructor<T> = {
    new (...args: any[]): T;
};
export type AbstractConstructor<T> = Function & {
    prototype: T;
};
export type PrimitiveConstructors = "String" | "Number" | "Boolean";
export type PrimitiveType = number | string | boolean;
export type PrimitiveArray = number[] | string[] | boolean[];
export type Optional<T, K extends keyof T> = Pick<Partial<T>, K> & Omit<T, K>;
export type RecursiveKeys<T> = T extends object ? {
    [K in keyof T]-?: T[K] extends infer RealTK | undefined ? RealTK extends (infer U)[] ? K extends string ? K | `${K}.${RecursiveKeys<U>}` : never : K extends string ? K | `${K}.${RecursiveKeys<T[K]>}` : never : never;
}[keyof T] : never;
export type RecursiveType<T, Name extends RecursiveKeys<T>> = T extends infer RealT | undefined ? Name extends keyof RealT ? RealT[Name] : Name extends `${infer K}.${infer Rest}` ? K extends keyof RealT ? Rest extends RecursiveKeys<RealT[K]> ? RecursiveType<RealT[K], Rest> : never : never : never : never;
